<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by TEMPLATED
http://templated.co
Released for free under the Creative Commons Attribution License

Name       : PlainDisplay 
Description: A two-column, fixed-width design with dark color scheme.
Version    : 1.0
Released   : 20140309

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title></title>
    <meta name="keywords" content=""/>
    <meta name="description" content=""/>
    <link href="http://fonts.googleapis.com/css?family=Varela" rel="stylesheet"/>
    <link href="http://fonts.googleapis.com/css?family=Inconsolata" rel="stylesheet" type="text/css"/>
    <link href="default.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="fonts.css" rel="stylesheet" type="text/css" media="all"/>
    <link rel="stylesheet" href="lib/codemirror.css">
    <link rel="stylesheet" href="theme/cobalt.css">

    <script src="lib/codemirror.js"></script>
    <script src="addon/edit/matchbrackets.js"></script>
    <script src="mode/zoomba/zoomba.js"></script>

    <!--[if IE 6]>
    <link href="default_ie6.css" rel="stylesheet" type="text/css"/><![endif]-->
</head>
<body>
<div id="wrapper">
    <div id="header-wrapper">
        <div id="header" class="container">
            <div id="logo">
                <h1><a style="text-transform: none; font-family:'Inconsolata',serif;font-size: 33pt;"
                       href="https://github.com/nmondal/ZoomBA/wiki">Zoo<i class="fa fa-bolt icon-mirrored" aria-hidden="true"></i><i class="fa fa-bolt" aria-hidden="true"></i>BA</a>
                </h1>
            </div>
            <div id="menu">
                <ul>
                    <li><a href="index.html" accesskey="1" title="">Home</a></li>
                    <li class="current_page_item"><a href="#" accesskey="2" title="">Learn</a></li>
                    <li><a href="experiment.html" accesskey="3" title="">Experiment</a></li>
                    <!-- <li><a href="delta.html" accesskey="4" title="">Delta</a></li> -->
                </ul>
            </div>
        </div>
    </div>
    <div id="extra" class="container">
        <div class="title">
            <h2>Get Introduced</h2>
            <span class="byline">To The Basic Constructs</span><br/><br/>
            <div id="three-column1">
                <div class="boxA" style="text-align: left;">
                    <textarea id="code1" name="code1">
/* basic types */
i = 1 // Integer
s1 = 'Single quoted string'
s2 = "Double quoted string"
d = 0.01 // double
b = true // boolean
/* Automatic Big Integer type */
n = 1970980981097210972011
/* Automatic Big Decimal type */
n = 197098098109.798098210972011
/* time  */
t = time()
/* null value */
foo = null
                    </textarea>
                </div>
                <div class="boxB" style="text-align: left;">
                    <textarea id="code2" name="code2">
/* basic flows */
i = 1
if ( i != 2 ){
   println('i is not 2')
}else{
   println ('i is 2')
}
i = 10
while( i >= 0 ){
  i -= 1
}
for ( i = 0 ; i < 10 ; i+= 1 ){
  println(i)
}
for ( i :[0:10] ){
  println(i)
}
for ( [0:10] ){
  println($) // implicit variable
}
                    </textarea>

                </div>
                <div class="boxC" style="text-align: left;">
<textarea id="code3" name="code3">
/* basic collections */
// a is array
a = [1,2,3,4,'foo bar']
// l is list
l = list( 1,'foo bar', false )
x = a[0] // x is 1
x = l.2 // x is false
// dictionary
d = {'t' : true , 'f' : false }
x = d[t] // true
x = d.f // false
// s: ( 1,3,4)
s = set(1,1,3,4,4)
/* range
from (including) : to (excluding) */
r = [0:10]
                    </textarea>
                </div>
            </div>
        </div>
    </div>

    <div id="extra2" class="container">
        <div class="title">
            <h2>Functionally Inclined</h2>
            <span class="byline">Practical Declarative Style</span><br/><br/>
            <div id="three-column2">
                <div class="boxA" style="text-align: left;">
                    <textarea id="code4" name="code4">
/*  anonymous function */
dl = list([1:5]) as { 2 * $.o }
// dl = [1,4,6,8]
// select evens up to n
evens = select([0:n]) where { $.o % 2 == 0 }
// partition even and odd
#(e,o) = partition([0:n]) where { $.o % 2 == 0 }
// find item where
x = [0,3,100, 34, 9]
// found := 2
found = index(x) where { $.o > 20 }
// found := 3
found = rindex(x) where { $.o > 20 }
// find factorial
fact = lfold([2:n+1],1) as { $.p *= $.o }
</textarea>
                </div>
                <div class="boxB" style="text-align: left;">
                    <textarea id="code5" name="code5">
/*  set algebra  */
a = [1,2,3,3,4]
b = [1,2,3,4]
c = [0,10,3]
a <=  b // true
a < b // true
//  union 
a | b == a // true 
// intersection 
a & c == [3] // true 
a < c // false 
c > a // false 
// Cartesian product 
a * b 
a** 2 // a * a ( power )
// [4,3,2,1] : reverse!
a ** -1 
</textarea>

                </div>
                <div class="boxC" style="text-align: left;">
<textarea id="code6" name="code6">
/* functions are first class  */
def benchmark_url(url,times){
  def call_url_with_timing(url){
    #(t,o) = read(url)
    return t
  }
  timings = list([0:times]) as {
    call_url_with_timing(url) 
    }
   timings = sortd(timings)
   inx = int ( 0.1 * times ) 
   ninety_p = timings[ inx ] 
}
urls={'http://www.google.co.in':10,
      'http://www.bing.com':10}
lfold(urls) as {
   printf( '%s -> %d\n',
   $.o.key, benchmark_url($.o.value) )
}
</textarea>
                </div>
            </div>
        </div>
    </div>

    <div id="extra4" class="container">
        <div class="title">
            <h2>Model Business Rules</h2>
            <span class="byline">By Indulging In Behavioural Paradigm</span><br/><br/>
            <div id="three-column4">
                <div class="boxA" style="text-align: left;">
                    <textarea id="code7" name="code7">
/* Model Transactions */
def transact(){ }
def before(){}
def after(){}
def on_error_rollback(){}
// assign event handlers
transact.before += before
transact.after += after
// catch errors
#(success ? e ) = transact()
empty(e) || on_error_rollback()
</textarea>
                </div>
                <div class="boxB" style="text-align: left;">
                    <textarea id="code8" name="code8">
/* Generalize Control Flow  */
def m1(){}
def m2(){}
def m3(){}
methods = [ m1, m2, m3 ]
def apply(input, methods ){
  lfold(methods, input) as {
   method = $.o
   $.p = method( @ARGS = $.p )
  }
}
</textarea>

                </div>
                <div class="boxC" style="text-align: left;">
<textarea id="code9" name="code9">
/* functions are first class  */
def benchmark_url(url,times){
  def call_url_with_timing(url){
    #(t,o) = read(url)
    return t
  }
  timings = list([0:times]) as {
    call_url_with_timing(url)
    }
   timings = sortd(timings)
   inx = int ( 0.1 * times )
   ninety_p = timings[ inx ]
}
urls={'http://www.google.co.in':10,
      'http://www.bing.com':10}
lfold(urls) as {
    printf( '%s -> %d\n',
    $.o.key, benchmark_url($.o.value) )
}
</textarea>
                </div>
            </div>
        </div>
    </div>

    <div id="extra3" class="container">
        <div class="title">
            <h2>Automate Code Validation </h2>
            <span class="byline">By Using Declarative Paradigm</span><br/><br/>
            <div id="three-column3">
                <div class="boxA" style="text-align: left;">
                    <textarea id="code10" name="code10">
/* Function sorts properly? */
l = list ( [ 0 : 100 ] )
// shuffle until shuffle happens
while ( !shuffle(l) ) ;
// call function under test
sl = ascending_sort_function(l)
// use declarative paradigm
sorted = ( l == sl ) &&
! exists (sl) where {
     $.i > 0 &&
       $.o < $.c[$.i - 1]
 }
</textarea>
                </div>
                <div class="boxB" style="text-align: left;">
                    <textarea id="code11" name="code11">
/* compare two lists of complex objects */
L = [o1, o2, o3, o4 ]
M = [O1, O2, O3, O4 ]
// L objects has these fields
LF = [ 'f11', 'f12', 'f13' ]
// M objects has these fields
MF = [ 'f21', 'f22', 'f23' ]
l = list(L) as { o = $.o
   lfold(LF,'') as { $.p += '#' + o[$.o] }
}
m = list(M) as { o = $.o
   lfold(MF,'') as { $.p += '#' + o[$.o] }
}
same = ( l == m )
</textarea>

                </div>
                <div class="boxC" style="text-align: left;">
<textarea id="code12" name="code12">
/* compare filtering
 P(x) is a predicate
 F is a filtered result from
 Collection C, applying P
*/
// most simple one
filtered =
    (F==select(C) where {P($.o)} )
// or in a round about way
filtered = ( F <= C ) &&
 // no x in C-F which is P(x)
 !exists(C-F)where { P($.o) } &&
 // no x in F which is not P(x)
 !exists (F) where { ! P($.o ) }
</textarea>
                </div>
            </div>
        </div>
        <ul class="actions">
            <li><a target="_blank" href="https://nmondal.github.io/assets/pdfs/zoomba.pdf"  class="button">Read The
                Manual</a></li>
        </ul>
    </div>

</div>


<div id="copyright" class="container">
    <p>&copy; ZoomBA.org. All rights reserved. | Photos by <a href="#"></a> | Design by <a
            href="http://templated.co"
            rel="nofollow"></a>TEMPLATED</p>
</div>
</body>
<script type="text/javascript">
    for (var i = 1; i < 20; i += 1) {
        var id = document.getElementById("code" + i);
        if (id == null) continue;
        var editor = CodeMirror.fromTextArea(id, {
            lineNumbers: false,
            matchBrackets: true,
            indentUnit: 2,
            theme: "cobalt",
            readOnly: true,
            lineWrapping : true,
            mode: "text/x-ZoomBA"
        });
    }
</script>

</html>
